/**
 * WARNING: This is a generated file. Do not modify.
 *
 * Source: buildscripts/idl/idlc.py --include src --base_dir build/fedora --header build/fedora/mongo/db/transactions_stats_gen.h --output build/fedora/mongo/db/transactions_stats_gen.cpp src/mongo/db/transactions_stats.idl
 */

#include "mongo/db/transactions_stats_gen.h"

#include <bitset>
#include <set>

#include "mongo/bson/bsonobjbuilder.h"
#include "mongo/db/commands.h"

namespace mongo {

constexpr StringData TransactionsStats::kRetriedCommandsCountFieldName;
constexpr StringData TransactionsStats::kRetriedStatementsCountFieldName;
constexpr StringData TransactionsStats::kTransactionsCollectionWriteCountFieldName;


TransactionsStats::TransactionsStats()  {
    // Used for initialization only
}

TransactionsStats TransactionsStats::parse(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    TransactionsStats object;
    object.parseProtected(ctxt, bsonObject);
    return object;
}
void TransactionsStats::parseProtected(const IDLParserErrorContext& ctxt, const BSONObj& bsonObject) {
    std::bitset<3> usedFields;
    const size_t kRetriedCommandsCountBit = 0;
    const size_t kRetriedStatementsCountBit = 1;
    const size_t kTransactionsCollectionWriteCountBit = 2;

    for (const auto& element :bsonObject) {
        const auto fieldName = element.fieldNameStringData();


        if (fieldName == kRetriedCommandsCountFieldName) {
            if (MONGO_unlikely(usedFields[kRetriedCommandsCountBit])) {
                ctxt.throwDuplicateField(element);
            }

            usedFields.set(kRetriedCommandsCountBit);

            if (MONGO_likely(ctxt.checkAndAssertType(element, NumberLong))) {
                _retriedCommandsCount = element._numberLong();
            }
        }
        else if (fieldName == kRetriedStatementsCountFieldName) {
            if (MONGO_unlikely(usedFields[kRetriedStatementsCountBit])) {
                ctxt.throwDuplicateField(element);
            }

            usedFields.set(kRetriedStatementsCountBit);

            if (MONGO_likely(ctxt.checkAndAssertType(element, NumberLong))) {
                _retriedStatementsCount = element._numberLong();
            }
        }
        else if (fieldName == kTransactionsCollectionWriteCountFieldName) {
            if (MONGO_unlikely(usedFields[kTransactionsCollectionWriteCountBit])) {
                ctxt.throwDuplicateField(element);
            }

            usedFields.set(kTransactionsCollectionWriteCountBit);

            if (MONGO_likely(ctxt.checkAndAssertType(element, NumberLong))) {
                _transactionsCollectionWriteCount = element._numberLong();
            }
        }
        else {
            ctxt.throwUnknownField(fieldName);
        }
    }


    if (MONGO_unlikely(!usedFields.all())) {
        if (!usedFields[kRetriedCommandsCountBit]) {
            _retriedCommandsCount = 0;
        }
        if (!usedFields[kRetriedStatementsCountBit]) {
            _retriedStatementsCount = 0;
        }
        if (!usedFields[kTransactionsCollectionWriteCountBit]) {
            _transactionsCollectionWriteCount = 0;
        }
    }

}


void TransactionsStats::serialize(BSONObjBuilder* builder) const {
    builder->append(kRetriedCommandsCountFieldName, _retriedCommandsCount);

    builder->append(kRetriedStatementsCountFieldName, _retriedStatementsCount);

    builder->append(kTransactionsCollectionWriteCountFieldName, _transactionsCollectionWriteCount);

}


BSONObj TransactionsStats::toBSON() const {
    BSONObjBuilder builder;
    serialize(&builder);
    return builder.obj();
}

}  // namespace mongo
